VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4635
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   4635
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCopyItems 
      Caption         =   "Mehrere Dateien oder Ordner aus der Zip entpacken"
      Height          =   585
      Left            =   90
      TabIndex        =   3
      Top             =   2010
      Width           =   4365
   End
   Begin VB.CommandButton cmdCopyItem 
      Caption         =   "Eine Datei oder ein Ordner aus der Zip entpacken"
      Height          =   585
      Left            =   90
      TabIndex        =   2
      Top             =   1350
      Width           =   4365
   End
   Begin VB.CommandButton cmdExtractAllZip 
      Caption         =   "Zip komplett entpacken"
      Height          =   585
      Left            =   90
      TabIndex        =   1
      Top             =   720
      Width           =   4365
   End
   Begin VB.CommandButton cmdCreateNewZip 
      Caption         =   "neue Zip erstellen und Dateien und Ordner rein kopieren"
      Height          =   585
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   4365
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

' Das zippen von Dateien und Ordner (AddItems) luft asynchron ab!!!
' Entpacken, Lschen, Kopieren und Verschieben usw. synchron!!!
' ansonsten knnen alle Funktionen auch auf normale Ordner und Dateien
' angewendet werden. Fr Zip-Dateien (komprimierter Ordner) gibt es
' einige Einschrnkungen. zb Leere Ordner in den Root der Zip zu kopieren
' ist nicht mglich. Ordner in der Zip knnen nicht ersetzt oder verschoben werden.
' Beim verschieben werden nur die Dateien verschoben.

' Pfade bitte entsprechend anpassen!!!

Private Sub cmdCreateNewZip_Click()

    ' erstellen einer neuen Zip-Datei und kopieren
    ' von Dateien und Ordner in die Zip
    
    Dim sZipFile As String
    Dim sFileOrFolder(1) As String
    
    ' Pfad\Filename.zip
    sZipFile = "C:\Downloads\test.zip"
    
    ' siehe AddItems Besonderheiten!!!
    ' sZipFile = "C:\Downloads\test.zip\Ordner\Unterordner"
    
    ' Array mit Dateien oder Ordner fllen, die in die Zip
    ' kopiert werden sollen.
    sFileOrFolder(0) = "C:\Downloads\test.txt" ' Datei
    sFileOrFolder(1) = "C:\Downloads\Ordner" ' Ordner
    
    ' eine leere Zip-Datei erstellen, falls sie noch nicht existiert
    If CreateEmptyZip(sZipFile) = True Then
    
        Debug.Print "Zip-Datei erstellt bzw war vorhanden"
        
        ' Besonderheit: Es kann bei AddItems -> sZipFile auch ein Ordner\Unterordner
        ' usw. in der Zip angegeben werden, sofern dieser Ordner in der Zip vorhanden ist.
        ' zb: Pfad\Filename.zip\Ordner\Unterordner usw. Dann werden die zu kopierenden
        ' Dateien und Ordner in diesen Ordner in der Zip kopiert.
        
        ' kopiert die Dateien und Ordner in eine vorhandene Zip-Datei.
        ' keinen Einflu auf Dialoge (SilentModus nicht mglich)
        If AddItems(sZipFile, sFileOrFolder) = True Then
        
            Debug.Print "Zippen erfolgreich"
        
        Else
            
            Debug.Print "Zippen nicht erfolgreich"
            
            ' bei Fehlschlag, Zip-Datei wieder lschen
            If DeleteItem(sZipFile) = True Then
            
                Debug.Print "Zip-Datei gelscht"

            End If
        End If
    End If

End Sub

Private Sub cmdExtractAllZip_Click()
    
    ' alles aus der Zip-Datei extrahieren
    
    Dim sZipFile As String
    Dim sToFolder As String

    ' Pfad\Filename.zip
    sZipFile = "C:\Downloads\test.zip"
    
    ' Zielordner
    sToFolder = "C:\Downloads\NewFolder"
    
    ' Zip-Datei komplett entpacken nach einem Ordner
    If UnzipAll(sZipFile, sToFolder) = True Then
    
        Debug.Print "Unzippen erfolgreich"
        
    End If
    
End Sub

Private Sub cmdCopyItem_Click()

    ' eine bestimmte Datei oder Ordner aus Zip-Datei extrahieren
    ' CopyItem kann nicht verwendet werden um Daten in eine Zip
    ' zu kopieren!!!

    Dim sFileOrFolder As String
    Dim sToFolder As String

    ' Pfad\Filename.zip\Ordner
    ' Pfad\Filename.zip\File.ext
    ' Pfad\Filename.zip\Ordner\File.ext
    ' Pfad\Filename.zip\Ordner\Unterordner
    ' usw.
    sFileOrFolder = "C:\Downloads\test.zip\test.txt"
    
    ' Zielordner
    sToFolder = "C:\Users\Schueler\Downloads\NewFolder"

    If CopyItem(sFileOrFolder, sToFolder) = True Then
    
        Debug.Print "Unzippen erfolgreich"
    
    End If
    
    ' analog dazu funktioniert auch die Funktion DeleteItem
    ' MoveItem funktioniert nicht mit Zip-Dateien bzw. nur
    ' mit Dateien in de Zip
    
End Sub

Private Sub cmdCopyItems_Click()

    ' mehrere Dateien oder Ordner aus Zip-Datei extrahieren
    ' CopyItems kann nicht verwendet werden um Daten in eine Zip
    ' zu kopieren!!!

    Dim sFileOrFolder(1) As String
    Dim sToFolder As String

    ' Pfad\Filename.zip\Ordner
    ' Pfad\Filename.zip\File.ext
    ' Pfad\Filename.zip\Ordner\File.ext
    ' Pfad\Filename.zip\Ordner\Unterordner
    ' usw.
    sFileOrFolder(0) = "C:\Downloads\test.zip\test.txt"
    sFileOrFolder(1) = "C:\Downloads\test.zip\Ordner"
    
    ' Zielordner
    sToFolder = "C:\Downloads\NewFolder"

    If CopyItems(sFileOrFolder, sToFolder) = True Then
    
        Debug.Print "Unzippen erfolgreich"
    
    End If

    ' analog dazu funktioniert auch die Funktion DeleteItems
    ' MoveItems funktioniert nicht mit Zip-Dateien bzw. nur
    ' mit Dateien in de Zip

End Sub
