VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIDataObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Private Const CLSID_DataObject As String = ""
    
Private Const IID_IDataObject As String = _
    "{0000010e-0000-0000-C000-000000000046}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetData
    vtb_GetDataHere
    vtb_QueryGetData
    vtb_GetCanonicalFormatEtc
    vtb_SetData
    vtb_EnumFormatEtc
    vtb_DAdvise
    vtb_DUnadvise
    vtb_EnumDAdvise
End Enum

Public Function SetData(ByVal pformatetc As Long, ByVal pmedium As Long, ByVal fRelease As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_SetData, pformatetc, pmedium, fRelease) Then

        bRet = True

    End If
    
    SetData = bRet

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_DataObject, _
            IID_IDataObject)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIDataObject", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub


