VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIDropTarget"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Private Const CLSID_DropTarget As String = ""
    
Private Const IID_IDropTarget As String = _
    "{00000122-0000-0000-C000-000000000046}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_DragEnter
    vtb_DragOver
    vtb_DragLeave
    vtb_Drop
End Enum

Public Function DragEnter(ByVal pDataObj As Long, ByVal grfKeyState As Long, ByVal pt As Long, ByVal pdwEffect As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_DragEnter, pDataObj, grfKeyState, pt, pdwEffect) Then

        bRet = True

    End If
    
    DragEnter = bRet

End Function

Public Function Drop(ByVal pDataObj As Long, ByVal grfKeyState As Long, ByVal pt As Long, ByVal pdwEffect As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If x_OleInvoke(vtb_Drop, pDataObj, grfKeyState, pt, pdwEffect) Then

        bRet = True

    End If
    
    Drop = bRet

End Function

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_DropTarget, _
            IID_IDropTarget)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIDropTarget", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub




