VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIFileOperation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Private Const CLSID_FileOperation As String = _
    "{3ad05575-8857-4850-9277-11b85bdb8e09}"
    
Private Const IID_IFileOperation As String = _
    "{947aab5f-0a5c-4c13-b4d6-4bf7836fc9f8}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_Advice
    vtb_Unadvise
    vtb_SetOperationFlags
    vtb_SetProgressMessage
    vtb_SetProgressDialog
    vtb_SetProperties
    vtb_SetOwnerWindow
    vtb_ApplyPropertiesToItem
    vtb_ApplyPropertiesToItems
    vtb_RenameItem
    vtb_RenameItems
    vtb_MoveItem
    vtb_MoveItems
    vtb_CopyItem
    vtb_CopyItems
    vtb_DeleteItem
    vtb_DeleteItems
    vtb_NewItem
    vtb_PerformOperations
    vtb_GetAnyOperationAborted
End Enum

Public Function Advise(ByVal pfops As Long) As Long

    Dim lRet As Long
    Dim pdwCookie As Long
    Dim ppdwCookie As Long
    
    ppdwCookie = VarPtr(pdwCookie)

    If x_OleInvoke(vtb_Advise, pfops, ppdwCookie) Then

        lRet = pdwCookie

    End If

    Advise = lRet

End Function

Public Function Unadvise(ByVal dwCookie As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_Unadvise, dwCookie) Then

        bRet = True

    End If

    Unadvise = bRet

End Function

Public Function SetOperationFlags(ByVal dwOperationFlags As Long) As Boolean
    
    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetOperationFlags, dwOperationFlags) Then

        bRet = True

    End If

    SetOperationFlags = bRet

End Function

Public Function SetProgressMessage(ByVal pszMessage As String) As Boolean

    ' This method is not implemented.
    
End Function

Public Function SetProgressDialog(ByVal popd As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetProgressDialog, popd) Then

        bRet = True

    End If

    SetProgressDialog = bRet

End Function

Public Function SetProperties(ByVal pproparray As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetProperties, pproparray) Then

        bRet = True

    End If

    SetProperties = bRet

End Function

Public Function SetOwnerWindow(ByVal hwndOwner As Long) As Boolean
    
    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetOwnerWindow, hwndOwner) Then

        bRet = True

    End If

    SetOwnerWindow = bRet

End Function

Public Function ApplyPropertiesToItem(ByVal psiItem As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_ApplyPropertiesToItem, psiItem) Then

        bRet = True

    End If

    ApplyPropertiesToItem = bRet

End Function

Public Function ApplyPropertiesToItems(ByVal punkItems As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_ApplyPropertiesToItems, punkItems) Then

        bRet = True

    End If

    ApplyPropertiesToItems = bRet

End Function

Public Function RenameItem(ByVal psiItem As Long, ByVal pszNewName As String, _
    ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszNewName As Long

    bRet = False
    ppszNewName = StrPtr(pszNewName)

    If x_OleInvoke(vtb_RenameItem, psiItem, ppszNewName, pfopsItem) Then

        bRet = True

    End If

    RenameItem = bRet

End Function

Public Function RenameItems(ByVal punkItems As Long, ByVal pszNewName As String) As Boolean

    Dim bRet As Boolean
    Dim ppszNewName As Long

    bRet = False
    ppszNewName = StrPtr(pszNewName)

    If x_OleInvoke(vtb_RenameItems, punkItems, ppszNewName) Then

        bRet = True

    End If

    RenameItems = bRet

End Function

Public Function MoveItem(ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszNewName As String, ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszNewName As Long

    bRet = False
    ppszNewName = StrPtr(pszNewName)

    If x_OleInvoke(vtb_MoveItem, psiItem, psiDestinationFolder, ppszNewName, _
        pfopsItem) Then

        bRet = True

    End If

    MoveItem = bRet

End Function

Public Function MoveItems(ByVal punkItems As Long, ByVal psiDestinationFolder As _
    Long) As Boolean

    Dim bRet As Boolean

    If x_OleInvoke(vtb_MoveItems, punkItems, psiDestinationFolder) Then

        bRet = True

    End If

    MoveItems = bRet

End Function

Public Function CopyItem(ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszCopyName As String, ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszCopyName As Long

    bRet = False
    ppszCopyName = StrPtr(pszCopyName)

    If x_OleInvoke(vtb_CopyItem, psiItem, psiDestinationFolder, ppszCopyName, _
        pfopsItem) Then

        bRet = True

    End If

    CopyItem = bRet

End Function

Public Function CopyItems(ByVal punkItems As Long, ByVal psiDestinationFolder As _
    Long) As Boolean

    Dim bRet As Boolean

    If x_OleInvoke(vtb_CopyItems, punkItems, psiDestinationFolder) Then

        bRet = True

    End If

    CopyItems = bRet

End Function

Public Function DeleteItem(ByVal psiItem As Long, ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_DeleteItem, psiItem, pfopsItem) Then

        bRet = True

    End If

    DeleteItem = bRet

End Function

Public Function DeleteItems(ByVal punkItems As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_DeleteItems, punkItems) Then

        bRet = True

    End If

    DeleteItems = bRet

End Function

Public Function NewItem(ByVal psiDestinationFolder As Long, ByVal dwFileAttributes _
    As Long, ByVal pszName As String, ByVal pszTemplateName As String, ByVal _
    pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszName As Long
    Dim ppszTemplateName As Long

    ppszName = StrPtr(pszName)
    ppszTemplateName = StrPtr(pszTemplateName)

    bRet = False

    If x_OleInvoke(vtb_NewItem, psiDestinationFolder, dwFileAttributes, ppszName, _
        ppszTemplateName, pfopsItem) Then

        bRet = True

    End If

    NewItem = bRet

End Function

Public Function PerformOperations() As Boolean
    
    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_PerformOperations) Then

        bRet = True

    End If

    PerformOperations = bRet

End Function

Public Function GetAnyOperationAborted() As Boolean
    
    Dim bRet As Boolean
    Dim pbRet As Long
    Dim ppbRet As Long
    
    ppbRet = VarPtr(pbRet)

    If x_OleInvoke(vtb_GetAnyOperationAborted, ppbRet) Then

        bRet = CBool(pbRet)

    End If

    GetAnyOperationAborted = bRet

End Function

Private Sub Class_Initialize()

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    m_initialized = InitInterface(m_Interface, CLSID_FileOperation, _
        IID_IFileOperation)

End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIFileOperation", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub

