Attribute VB_Name = "modZIP"
Option Explicit

' Funktion AddItems, GetPIDLFromPath und GetDropTarget bsieren auf:
' http://www.mvps.org/emorcillo/download/vb6/xpzip.zip
' http://www.vbforums.com/showthread.php?808681-VB6-Create-a-ZIP-file-without-any-DLL-depends-using-IStorage-and-IDropTarget

' alle anderen Funktionen mit dem IFileOperation Interface basieren auf
' http://www.vbforums.com/showthread.php?779005-VB6-Use-IFileOperation-to-replace-SHFileOperation-for-modern-Copy-Move-box-prompts

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

' **************** Const ****************
Private Const S_OK As Long = &H0&
Private Const FO_COPY As Long = &H2&
Private Const CF_HDROP As Long = &HF&
Private Const DVASPECT_CONTENT As Long = &H1&
Private Const TYMED_HGLOBAL As Long = &H1&
Private Const GMEM_MOVEABLE As Long = &H2&
Private Const GMEM_ZEROINIT As Long = &H40&
Private Const GHND As Long = GMEM_MOVEABLE Or GMEM_ZEROINIT
Private Const MK_LBUTTON As Long = &H1&
Private Const DROPEFFECT_COPY As Long = &H1&
Private Const INVALID_FILE_ATTRIBUTES As Long = -1&

Private Const IID_IDataObject As String = "{0000010E-0000-0000-C000-000000000046}"
Private Const IID_IDropTarget As String = "{00000122-0000-0000-C000-000000000046}"

' **************** Enum ****************
' GetFileAttributes und CreateItem
Public Enum FileAttributes
    FILE_ATTRIBUTE_READONLY = &H1
    FILE_ATTRIBUTE_HIDDEN = &H2
    FILE_ATTRIBUTE_SYSTEM = &H4
    FILE_ATTRIBUTE_DIRECTORY = &H10
    FILE_ATTRIBUTE_ARCHIVE = &H20
    FILE_ATTRIBUTE_DEVICE = &H40
    FILE_ATTRIBUTE_NORMAL = &H80
    FILE_ATTRIBUTE_TEMPORARY = &H100
    FILE_ATTRIBUTE_SPARSEFILE = &H200
    FILE_ATTRIBUTE_REPARSEPOINT = &H400
    FILE_ATTRIBUTE_COMPRESSED = &H800
    FILE_ATTRIBUTE_OFFLINE = &H1000
    FILE_ATTRIBUTE_NOTCONTENTINDEX = &H2000
    FILE_ATTRIBUTE_ENCRYPTED = &H4000
    FILE_ATTRIBUTE_INTEGRITYSTREAM = &H7FFF
    FILE_ATTRIBUTE_NOSCRUBDATA = &H20000
End Enum

' SHFileOperation und IFileOperation.SetOperationFlags
Public Enum FileOperationFlags
    FOF_MULTIDESTFILES = &H1
    FOF_CONFIRMMOUSE = &H2
    FOF_SILENT = &H4
    FOF_RENAMEONCOLLISION = &H8
    FOF_NOCONFIRMATION = &H10
    FOF_WANTMAPPINGHANDLE = &H20
    FOF_ALLOWUNDO = &H40
    FOF_FILESONLY = &H80
    FOF_SIMPLEPROGRESS = &H100
    FOF_NOCONFIRMMKDIR = &H200
    FOF_NOERRORUI = &H400
    FOF_NORECURSION = &H1000
    FOF_NOCOPYSECURITYATTRIBS = &H800
    FOF_NO_CONNECTED_ELEMENTS = &H2000
    FOF_WANTNUKEWARNING = &H4000
    FOF_NORECURSEREPARSE = &H8000&
    FOF_NO_UI = FOF_SILENT Or FOF_NOCONFIRMATION Or FOF_NOERRORUI Or FOF_NOCONFIRMMKDIR
End Enum

'  IShellItem.GetDisplayName
Public Enum SIGDN
    SIGDN_NORMALDISPLAY = &H0
    SIGDN_PARENTRELATIVEPARSING = &H80018001
    SIGDN_DESKTOPABSOLUTEPARSING = &H80028000
    SIGDN_PARENTRELATIVEEDITING = &H80031001
    SIGDN_DESKTOPABSOLUTEEDITING = &H8004C000
    SIGDN_FILESYSPATH = &H80058000
    SIGDN_URL = &H80068000
    SIGDN_PARENTRELATIVEFORADDRESSBAR = &H8007C001
    SIGDN_PARENTRELATIVE = &H80080001
    SIGDN_PARENTRELATIVEFORUI = &H80094001
End Enum

' IShellItem.GetAttributes
Public Enum SFGAO
    SFGAO_CANCOPY = &H1
    SFGAO_CANMOVE = &H2
    SFGAO_CANLINK = &H4
    SFGAO_STORAGE = &H8
    SFGAO_CANRENAME = &H10
    SFGAO_CANDELETE = &H20
    SFGAO_HASPROPSHEET = &H40
    SFGAO_DROPTARGET = &H100
    SFGAO_CAPABILITYMASK = &H177
    SFGAO_ENCRYPTED = &H2000
    SFGAO_ISSLOW = &H4000
    SFGAO_GHOSTED = &H8000
    SFGAO_LINK = &H10000
    SFGAO_SHARE = &H20000
    SFGAO_READONLY = &H40000
    SFGAO_HIDDEN = &H80000
    SFGAO_DISPLAYATTRMASK = &HFC000
    SFGAO_FILESYSANCESTOR = &H10000000
    SFGAO_FOLDER = &H20000000
    SFGAO_FILESYSTEM = &H40000000
    SFGAO_HASSUBFOLDER = &H80000000
    SFGAO_CONTENTSMASK = &H80000000
    SFGAO_VALIDATE = &H1000000
    SFGAO_REMOVABLE = &H2000000
    SFGAO_COMPRESSED = &H4000000
    SFGAO_BROWSABLE = &H8000000
    SFGAO_NONENUMERATED = &H100000
    SFGAO_NEWCONTENT = &H200000
    SFGAO_CANMONIKER = &H400000
    SFGAO_HASSTORAGE = &H400000
    SFGAO_STREAM = &H400000
    SFGAO_STORAGEANCESTOR = &H800000
    SFGAO_STORAGECAPMASK = &H70C50008
End Enum

' IShellItem.Compare
Public Enum SICHINTF
    SICHINT_DISPLAY = &H0
    SICHINT_CANONICAL = &H10000000
    SICHINT_TEST_FILESYSPATH_IF_NOT_EQUAL = &H20000000
    SICHINT_ALLFIELDS = &H80000000
End Enum

' IShellFolder.EnumObjects
Public Enum SHCONTF
    SHCONTF_CHECKING_FOR_CHILDREN = &H10
    SHCONTF_FOLDERS = &H20
    SHCONTF_NONFOLDERS = &H40
    SHCONTF_INCLUDEHIDDEN = &H80
    SHCONTF_INIT_ON_FIRST_NEXT = &H100
    SHCONTF_NETPRINTERSRCH = &H200
    SHCONTF_SHAREABLE = &H400
    SHCONTF_STORAGE = &H800
    SHCONTF_NAVIGATION_ENUM = &H1000
    SHCONTF_FASTITEMS = &H2000
    SHCONTF_FLATLIST = &H4000
    SHCONTF_ENABLE_ASYNC = &H8000
    SHCONTF_INCLUDESUPERHIDDEN = &H10000
End Enum

' **************** Type ****************
' DROPFILES.pt
Private Type POINTAPI
    x As Long
    y As Long
End Type

' IDataObject.SetData -> STGMEDIUM.hGlobal
Private Type DROPFILES
    pFiles As Long
    pt As POINTAPI
    fNC As Long
    fWide As Long
End Type

' SHFileOperation
Private Type SHFILEOPSTRUCT
    hWnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAborted As Boolean
    hNameMaps As Long
    sProgressTitle As String
End Type

' IDataObject.SetData
Private Type FORMATETC
    cfFormat As Long
    ptd As Long
    dwAspect As Long
    lIndex As Long
    Tymed As Long
End Type

' IDataObject.SetData
Private Type STGMEDIUM
    Tymed As Long
    hGlobal As Long
    pUnkForRelease As Long
End Type

' IShellFolder.GetUIObjectOf
Private Type ITEMIDLIST
    mkid As Long
End Type

' **************** Shell32.dll ****************
Private Declare Function SHGetDesktopFolder Lib "shell32" ( _
                         ByRef ppshf As Long) As Long

Private Declare Function SHCreateShellItem Lib "shell32" ( _
                         ByVal pidlParent As Long, _
                         ByVal psfParent As Long, _
                         ByVal pidl As Long, _
                         ByRef ppsi As Long) As Long

Private Declare Function SHCreateShellItemArrayFromIDLists Lib "shell32" ( _
                         ByVal cidl As Long, _
                         ByVal rgpidl As Long, _
                         ByRef ppsiItemArray As Long) As Long

Private Declare Function SHFileOperation Lib "shell32" ( _
                         ByRef FileOpStruct As SHFILEOPSTRUCT) As Long

Private Declare Function SHCreateDataObject Lib "shell32" ( _
                         ByVal pidlFolder As Long, _
                         ByVal cidl As Long, _
                         ByRef apidl As Long, _
                         ByVal pdtInner As IUnknown, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

' **************** Ole32.dll ****************
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" ( _
                    ByVal pv As Long)

' **************** Kernel32.dll ****************
Private Declare Function GetFileAttributes Lib "kernel32" _
                         Alias "GetFileAttributesA" ( _
                         ByVal lpFileName As String) As Long

Private Declare Function GlobalAlloc Lib "kernel32" ( _
                         ByVal wFlags As Long, _
                         ByVal dwBytes As Long) As Long

Private Declare Function GlobalFree Lib "kernel32" ( _
                         ByVal hMem As Long) As Long

Private Declare Function GlobalLock Lib "kernel32" ( _
                         ByVal hMem As Long) As Long

Private Declare Function GlobalUnlock Lib "kernel32" ( _
                         ByVal hMem As Long) As Long

Private Declare Sub CopyMem Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

' **************** Imagehlp.dll ****************
Private Declare Function MakePath Lib "imagehlp" _
                         Alias "MakeSureDirectoryPathExists" ( _
                         ByVal lpPath As String) As Long

' erstellt eine leere ZIP-Datei
Public Function CreateEmptyZip(ByVal sZipFile As String) As Boolean

    Dim bRet As Boolean
    Dim lFNr As Long
    Dim bZipHeader(21) As Byte
    
    bRet = False
    
    ' nur wenn Datei nicht vorhanden ist
    If FileExists(sZipFile) = False Then
    
        ' Zip-Header
        bZipHeader(0) = 80
        bZipHeader(1) = 75
        bZipHeader(2) = 5
        bZipHeader(3) = 6

        ' freie Dateinummer holen
        lFNr = FreeFile

        ' Zip-Datei erstellen
        Open sZipFile For Binary Access Write As #lFNr

            ' Zip-Header in Datei schreiben
            Put #lFNr, , bZipHeader

        ' Dateizugriff schlieen
        Close #lFNr
    
    End If
    
    ' Rckgabe ob die Zip-Datei vorhanden ist
    CreateEmptyZip = FileExists(sZipFile)

End Function

' fgt Dateien und Ordner per Drag&Drop einer Zip-Datei hinzu
Public Function AddItems(ByVal sZipFile As String, _
    ByRef sFileOrFolder() As String) As Boolean

    Dim bRet As Boolean
    Dim sFile As String
    Dim sFiles As String
    Dim lItem As Long
    Dim lCount As Long
    Dim hGlobal As Long
    Dim lpGlobal As Long
    Dim lDstPIDL As Long
    Dim ptFORMATETC As Long
    Dim ptSTGMEDIUM As Long
    Dim pIDataObject As Long
    Dim pIDropTarget As Long
    Dim pIShellFolder As Long
    Dim psIID_IDataObject As Long
    Dim ptIID_IDataObject As Long
    Dim tIID_IDataObject(3) As Long
    Dim tDROPFILES As DROPFILES
    Dim tFORMATETC As FORMATETC
    Dim tSTGMEDIUM As STGMEDIUM

    bRet = False

    ' PIDL der Zip-Datei ermitteln
    lDstPIDL = GetPIDLFromPath(sZipFile)

    If lDstPIDL <> 0& Then

        ' IDropTarget der Zip-Datei ermitteln
        pIDropTarget = GetDropTarget(lDstPIDL)

        If pIDropTarget <> 0& Then

            ' IDropTarget-Interface initialisieren
            Dim IDropTarget As New clsIDropTarget
            Call IDropTarget.Initialize(pIDropTarget)

            ' Anzahl der zu droppenden Dateien/Ordner
            lCount = UBound(sFileOrFolder)

            ' alle zu droppenden Dateien/Ordner durchlaufen
            For lItem = 0 To lCount

                ' eine Datei oder Ordner aus dem Array
                sFile = sFileOrFolder(lItem)

                ' Backslash entfernen falls vorhanden
                If Right$(sFile, 1&) = "\" Then sFile = Mid$(sFile, 1&, _
                    Len(sFile) - 1&)

                ' Datei oder Ordner durch vbNullChar getrennt zu einer
                ' Zeichenkette zusammenfgen
                sFiles = sFiles & sFile & vbNullChar

            Next

            ' Zeichenkette am Ende mit zwei vbNullChar
            sFiles = sFiles & vbNullChar

            ' Speicher allokieren
            hGlobal = GlobalAlloc(GHND, Len(tDROPFILES) + Len(sFiles))

            If hGlobal <> 0& Then

                ' Pointer auf den Speicher holen
                lpGlobal = GlobalLock(hGlobal)

                If lpGlobal <> 0& Then

                    ' tDROPFILES fllen
                    tDROPFILES.pFiles = Len(tDROPFILES)

                    Call CopyMem(ByVal lpGlobal, tDROPFILES, Len(tDROPFILES))

                    Call CopyMem(ByVal (lpGlobal + Len(tDROPFILES)), ByVal sFiles, _
                        Len(sFiles))

                End If

                ' Speicher entsperren
                Call GlobalUnlock(hGlobal)

                ' FORMATETC fllen
                With tFORMATETC

                    .cfFormat = CF_HDROP
                    .dwAspect = DVASPECT_CONTENT
                    .lIndex = -1&
                    .ptd = 0&
                    .Tymed = TYMED_HGLOBAL

                End With
                
                ' STGMEDIUM fllen
                With tSTGMEDIUM

                    .Tymed = TYMED_HGLOBAL
                    .hGlobal = hGlobal

                End With

                ' IID_IDataObject -> tIID_IDataObject
                psIID_IDataObject = StrPtr(IID_IDataObject)
                ptIID_IDataObject = VarPtr(tIID_IDataObject(0))
                Call IIDFromString(psIID_IDataObject, ptIID_IDataObject)

                ' ein IDataObject erstellen
                If SHCreateDataObject(0&, 1&, 0&, Nothing, ptIID_IDataObject, _
                    pIDataObject) = S_OK Then

                    ' IDataObject-Interface initialisieren
                    Dim IDataObject As New clsIDataObject
                    Call IDataObject.Initialize(pIDataObject)

                    ptFORMATETC = VarPtr(tFORMATETC)
                    ptSTGMEDIUM = VarPtr(tSTGMEDIUM)

                    ' Typ und Daten fr das IDataObject festlegen
                    If IDataObject.SetData(ptFORMATETC, ptSTGMEDIUM, 1&) = True Then

                        ' Drag&Drop simulieren (Kopieren)
                        ' dadurch werden die zu droppenden Dateien und Ordner in
                        ' einem anderen Ordner kopiert
                        If IDropTarget.DragEnter(pIDataObject, MK_LBUTTON, 0&, _
                            DROPEFFECT_COPY) = True Then

                            If IDropTarget.Drop(pIDataObject, MK_LBUTTON, 0&, _
                                DROPEFFECT_COPY) = True Then

                                bRet = True

                            End If
                        End If
                    End If

                    ' aufrumen
                    Set IDataObject = Nothing

                End If
                
                ' aufrumen
                Call GlobalFree(hGlobal)

            End If

            ' aufrumen
            Set IDropTarget = Nothing

        End If

        ' aufrumen
        Call CoTaskMemFree(lDstPIDL)

    End If

    AddItems = bRet

End Function

' CreateItem funktioniert nicht mit Zip-Dateien!!!
' erstellt eine leere Datei oder Ordner in einem Ordner
Public Function CreateItem(ByVal sFolder As String, ByVal sNewItem As _
    String, Optional ByVal FileFlags As FileAttributes = FILE_ATTRIBUTE_NORMAL, _
    Optional ByVal Flags As FileOperationFlags = FOF_NO_UI, Optional ByVal _
    hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lDstPIDL As Long
    Dim pDstIShellItem As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False
    
    ' existiert der Zielordner nicht
    If DirExists(sFolder) = False Then
    
        ' dann den Zielordner anlegen
        Call CreatePath(sFolder)
        
    End If
    
    ' PIDL der Datei oder Ordner ermitteln
    lDstPIDL = GetPIDLFromPath(sFolder)

    If lDstPIDL <> 0& Then
        
        ' IShellItem von PIDL erstellen
        If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

            ' IShellItem Interface initialisieren
            Dim IShellItem As New clsIShellItem
            Call IShellItem.Initialize(pDstIShellItem)

            ' IFileOperation Interface erstellen
            Set IFileOperation = New clsIFileOperation

            If Not IFileOperation Is Nothing Then

                ' div. Eigenschaften festlegen
                If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                    If IFileOperation.SetOperationFlags(Flags) = True Then

                        ' neues Item
                        If IFileOperation.NewItem(pDstIShellItem, FileFlags, _
                            sNewItem, vbNullString, 0&) = True Then

                            ' Aktion ausfhren
                            bRet = IFileOperation.PerformOperations

                        End If
                    End If
                End If

                ' aufrumen
                Set IFileOperation = Nothing

            End If

            ' aufrumen
            Set IShellItem = Nothing

        End If

        ' aufrumen
        Call CoTaskMemFree(lDstPIDL)

    End If

    CreateItem = bRet

End Function

' kopiert eine Datei oder einen Ordner zu einem anderen Ordner
Public Function CopyItem(ByVal sFileOrFolder As String, ByVal _
    sToFolder As String, Optional ByVal Flags As FileOperationFlags = FOF_NO_UI, _
    Optional ByVal hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lSrcPIDL As Long
    Dim lDstPIDL As Long
    Dim pSrcIShellItem As Long
    Dim pDstIShellItem As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False

    ' PIDL der Datei oder Ordner ermitteln (Quelle)
    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    If lSrcPIDL <> 0& Then

        ' existiert der Zielordner nicht
        If DirExists(sToFolder) = False Then
    
            ' dann den Zielordner anlegen
            Call CreatePath(sToFolder)
        
        End If

        ' PIDL des Ordners ermitteln (Ziel)
        lDstPIDL = GetPIDLFromPath(sToFolder)

        If lDstPIDL <> 0& Then

            ' IShellItem fr die Quelle erstellen
            If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

                ' IShellItem Interface initialisieren
                Dim IShellItemSrc As New clsIShellItem
                Call IShellItemSrc.Initialize(pSrcIShellItem)

                ' IShellItem fr das Ziel erstellen
                If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                    ' IShellItem Interface initialisieren
                    Dim IShellItemDst As New clsIShellItem
                    Call IShellItemDst.Initialize(pDstIShellItem)

                    ' IFileOperation Interface erstellen
                    Set IFileOperation = New clsIFileOperation

                    If Not IFileOperation Is Nothing Then

                        ' div. Eigenschaften festlegen
                        If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                            If IFileOperation.SetOperationFlags(Flags) = True Then

                                ' Kopieren
                                If IFileOperation.CopyItem(pSrcIShellItem, _
                                    pDstIShellItem, vbNullString, 0&) = True Then

                                    ' Aktion ausfhren
                                    bRet = IFileOperation.PerformOperations

                                End If
                            End If
                        End If

                        ' aufrumen
                        Set IFileOperation = Nothing

                    End If

                    ' aufrumen
                    Set IShellItemDst = Nothing

                End If

                ' aufrumen
                Set IShellItemSrc = Nothing

            End If

            ' aufrumen
            Call CoTaskMemFree(lDstPIDL)

        End If

        ' aufrumen
        Call CoTaskMemFree(lSrcPIDL)

    End If

    CopyItem = bRet

End Function

' kopiert mehrere Dateien oder Ordner zu einem anderen Ordner
Public Function CopyItems(ByRef sFileOrFolder() As String, _
    ByVal sToFolder As String, Optional ByVal Flags As FileOperationFlags = _
    FOF_NO_UI, Optional ByVal hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim lDstPIDL As Long
    Dim pDstIShellItem As Long
    Dim pSrcIShellItemArray As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False
    lCounter = 0

    ' Anzahl der zu kopierenden Dateien/Ordner
    lCount = UBound(sFileOrFolder)

    ' alle Dateien/Ordner durclaufen
    For lItem = 0 To lCount

        If lCounter = 0 Then

            ReDim lSrcPIDL(lCounter)

        Else

            ReDim Preserve lSrcPIDL(lCounter)

        End If

        ' PIDL der zu kopierenden Dateien oder der Ordner ermitteln
        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        If lPIDL <> 0& Then

            lSrcPIDL(lCounter) = lPIDL
            lCounter = lCounter + 1

        End If

    Next

    ' existiert der Zielordner nicht
    If DirExists(sToFolder) = False Then
    
        ' dann den Zielordner anlegen
        Call CreatePath(sToFolder)
        
    End If

    ' PIDL des Zielordners ermitteln
    lDstPIDL = GetPIDLFromPath(sToFolder)

    If lDstPIDL <> 0& Then
        
        pSrcPIDL = VarPtr(lSrcPIDL(0))
        
        ' ein IShellItemArray erstellen
        If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, _
            pSrcIShellItemArray) = S_OK Then

            ' IShellItemArray Interface initialisieren
            Dim IShellItemArraySrc As New clsIShellItemArray
            Call IShellItemArraySrc.Initialize(pSrcIShellItemArray)
            
            ' ein IShellItem erstellen
            If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                ' IShellItem Interface initialisieren
                Dim IShellItemDst As New clsIShellItem
                Call IShellItemDst.Initialize(pDstIShellItem)

                ' IFileOperation erstellen
                Set IFileOperation = New clsIFileOperation

                If Not IFileOperation Is Nothing Then

                    ' div. Eigenschaften festlegen
                    If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                        If IFileOperation.SetOperationFlags(Flags) = True Then

                            ' mehrere Dateien/Ordner kopieren
                            If IFileOperation.CopyItems(pSrcIShellItemArray, _
                                pDstIShellItem) = True Then

                                ' Aktion ausfhren
                                bRet = IFileOperation.PerformOperations

                            End If
                        End If
                    End If

                    ' aufrumen
                    Set IFileOperation = Nothing

                End If

                ' aufrumen
                Set IShellItemDst = Nothing

            End If

            ' aufrumen
            Set IShellItemArraySrc = Nothing

        End If

        ' aufrumen
        For lItem = 0 To lCounter - 1

            Call CoTaskMemFree(lSrcPIDL(lItem))

        Next

        ' aufrumen
        Call CoTaskMemFree(lDstPIDL)

    End If

    CopyItems = bRet

End Function

' MoveItem funktioniert nicht mit ZIP-Dateien!!!
' Verschiebt eine Datei oder ein Ordner zu einem anderen Ordner
Public Function MoveItem(ByVal sFileOrFolder As String, ByVal _
    sToFolder As String, Optional ByVal Flags As FileOperationFlags = FOF_NO_UI, _
    Optional ByVal hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lSrcPIDL As Long
    Dim lDstPIDL As Long
    Dim pSrcIShellItem As Long
    Dim pDstIShellItem As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False

    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    If lSrcPIDL <> 0& Then

        ' existiert der Zielordner nicht
        If DirExists(sToFolder) = False Then
    
            ' dann den Zielordner anlegen
            Call CreatePath(sToFolder)
        
        End If

        lDstPIDL = GetPIDLFromPath(sToFolder)

        If lDstPIDL <> 0& Then

            If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

                Dim IShellItemSrc As New clsIShellItem
                Call IShellItemSrc.Initialize(pSrcIShellItem)

                If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                    Dim IShellItemDst As New clsIShellItem
                    Call IShellItemDst.Initialize(pDstIShellItem)

                    Set IFileOperation = New clsIFileOperation

                    If Not IFileOperation Is Nothing Then

                        If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                            If IFileOperation.SetOperationFlags(Flags) = True Then

                                If IFileOperation.MoveItem(pSrcIShellItem, _
                                    pDstIShellItem, vbNullString, 0&) = True Then

                                    bRet = IFileOperation.PerformOperations

                                End If
                            End If
                        End If

                        Set IFileOperation = Nothing

                    End If

                    Set IShellItemDst = Nothing

                End If

                Set IShellItemSrc = Nothing

            End If

            Call CoTaskMemFree(lDstPIDL)

        End If

        Call CoTaskMemFree(lSrcPIDL)

    End If

    MoveItem = bRet

End Function

' MoveItems funktioniert nicht mit ZIP-Dateien!!!
' Verschiebt mehrere Dateien oder Ordner zu einem anderen Ordner
Public Function MoveItems(ByRef sFileOrFolder() As String, _
    ByVal sToFolder As String, Optional ByVal Flags As FileOperationFlags = _
    FOF_NO_UI, Optional ByVal hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim lDstPIDL As Long
    Dim pDstIShellItem As Long
    Dim pSrcIShellItemArray As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False
    lCounter = 0

    lCount = UBound(sFileOrFolder)

    For lItem = 0 To lCount

        If lCounter = 0 Then

            ReDim lSrcPIDL(lCounter)

        Else

            ReDim Preserve lSrcPIDL(lCounter)

        End If

        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        If lPIDL <> 0& Then

            lSrcPIDL(lCounter) = lPIDL
            lCounter = lCounter + 1

        End If

    Next

    ' existiert der Zielordner nicht
    If DirExists(sToFolder) = False Then
    
        ' dann den Zielordner anlegen
        Call CreatePath(sToFolder)
        
    End If

    lDstPIDL = GetPIDLFromPath(sToFolder)

    If lDstPIDL <> 0& Then

        pSrcPIDL = VarPtr(lSrcPIDL(0))

        If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, _
            pSrcIShellItemArray) = S_OK Then

            Dim IShellItemArraySrc As New clsIShellItemArray
            Call IShellItemArraySrc.Initialize(pSrcIShellItemArray)

            If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                Dim IShellItemDst As New clsIShellItem
                Call IShellItemDst.Initialize(pDstIShellItem)

                Set IFileOperation = New clsIFileOperation

                If Not IFileOperation Is Nothing Then

                    If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                        If IFileOperation.SetOperationFlags(Flags) = True Then

                            If IFileOperation.MoveItems(pSrcIShellItemArray, _
                                pDstIShellItem) = True Then

                                bRet = IFileOperation.PerformOperations

                            End If
                        End If
                    End If

                    Set IFileOperation = Nothing

                End If

                Set IShellItemDst = Nothing

            End If

            Set IShellItemArraySrc = Nothing

        End If

        For lItem = 0 To lCounter - 1

            Call CoTaskMemFree(lSrcPIDL(lItem))

        Next

        Call CoTaskMemFree(lDstPIDL)

    End If

    MoveItems = bRet

End Function

' lscht eine Datei oder Ordner
Public Function DeleteItem(ByVal sFileOrFolder As String, _
    Optional ByVal Flags As FileOperationFlags = FOF_NO_UI, Optional ByVal _
    hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lSrcPIDL As Long
    Dim pSrcIShellItem As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False

    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    If lSrcPIDL <> 0& Then

        If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

            Dim IShellItemSrc As New clsIShellItem

            Call IShellItemSrc.Initialize(pSrcIShellItem)

            Set IFileOperation = New clsIFileOperation

            If Not IFileOperation Is Nothing Then

                If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                    If IFileOperation.SetOperationFlags(Flags) = True Then

                        If IFileOperation.DeleteItem(pSrcIShellItem, 0&) = True Then

                            bRet = IFileOperation.PerformOperations

                        End If
                    End If
                End If

                Set IFileOperation = Nothing

            End If

            Set IShellItemSrc = Nothing

        End If

        Call CoTaskMemFree(lSrcPIDL)

    End If

    DeleteItem = bRet

End Function

' lscht mehrere Dateien oder Ordner
Public Function DeleteItems(ByRef sFileOrFolder() As String, _
    Optional ByVal Flags As FileOperationFlags = FOF_NO_UI, Optional ByVal _
    hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim pSrcIShellItemArray As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False
    lCounter = 0

    lCount = UBound(sFileOrFolder)

    For lItem = 0 To lCount

        If lCounter = 0 Then

            ReDim lSrcPIDL(lCounter)

        Else

            ReDim Preserve lSrcPIDL(lCounter)

        End If

        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        If lPIDL <> 0& Then

            lSrcPIDL(lCounter) = lPIDL
            lCounter = lCounter + 1

        End If

    Next

    pSrcPIDL = VarPtr(lSrcPIDL(0))

    If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, pSrcIShellItemArray) _
        = S_OK Then

        Dim IShellItemArraySrc As New clsIShellItemArray
        Call IShellItemArraySrc.Initialize(pSrcIShellItemArray)

        Set IFileOperation = New clsIFileOperation

        If Not IFileOperation Is Nothing Then

            If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                If IFileOperation.SetOperationFlags(Flags) = True Then

                    If IFileOperation.DeleteItems(pSrcIShellItemArray) = True Then

                        bRet = IFileOperation.PerformOperations

                    End If
                End If
            End If

            Set IFileOperation = Nothing

        End If

        Set IShellItemArraySrc = Nothing

    End If

    For lItem = 0 To lCounter - 1

        Call CoTaskMemFree(lSrcPIDL(lItem))

    Next

    DeleteItems = bRet

End Function

' RenameItem funktioniert nicht mit ZIP-Dateien!!!
' umbenennen einer Datei oder eines Ordners
Public Function RenameItem(ByVal sFileOrFolder As String, _
    ByVal sNewName As String, Optional ByVal Flags As FileOperationFlags = _
    FOF_NO_UI, Optional ByVal hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lSrcPIDL As Long
    Dim pSrcIShellItem As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False

    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    If lSrcPIDL <> 0& Then

        If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

            Dim IShellItemSrc As New clsIShellItem

            Call IShellItemSrc.Initialize(pSrcIShellItem)

            Set IFileOperation = New clsIFileOperation

            If Not IFileOperation Is Nothing Then

                If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                    If IFileOperation.SetOperationFlags(Flags) = True Then

                        If IFileOperation.RenameItem(pSrcIShellItem, sNewName, 0&) _
                            = True Then

                            bRet = IFileOperation.PerformOperations

                        End If
                    End If
                End If

                Set IFileOperation = Nothing

            End If

            Set IShellItemSrc = Nothing

        End If

        Call CoTaskMemFree(lSrcPIDL)

    End If

    RenameItem = bRet

End Function

' RenameItems funktioniert nicht mit ZIP-Dateien!!!
' mehrer Dateien oder Ordner umbenennen
Public Function RenameItems(ByRef sFileOrFolder() As String, _
    ByVal sNewName As String, Optional ByVal Flags As FileOperationFlags = _
    FOF_NO_UI, Optional ByVal hwndOwner As Long = 0&) As Boolean

    Dim bRet As Boolean
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim pSrcIShellItemArray As Long
    Dim IFileOperation As clsIFileOperation

    bRet = False
    lCounter = 0

    lCount = UBound(sFileOrFolder)

    For lItem = 0 To lCount

        If lCounter = 0 Then

            ReDim lSrcPIDL(lCounter)

        Else

            ReDim Preserve lSrcPIDL(lCounter)

        End If

        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        If lPIDL <> 0& Then

            lSrcPIDL(lCounter) = lPIDL
            lCounter = lCounter + 1

        End If

    Next
    
    pSrcPIDL = VarPtr(lSrcPIDL(0))
    
    If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, _
        pSrcIShellItemArray) = S_OK Then

        Dim IShellItemArraySrc As New clsIShellItemArray

        Call IShellItemArraySrc.Initialize(pSrcIShellItemArray)

        Set IFileOperation = New clsIFileOperation

        If Not IFileOperation Is Nothing Then

            If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                If IFileOperation.SetOperationFlags(Flags) = True Then

                    If IFileOperation.RenameItems(pSrcIShellItemArray, sNewName) = _
                        True Then

                        bRet = IFileOperation.PerformOperations

                    End If
                End If
            End If

            Set IFileOperation = Nothing

        End If

        Set IShellItemArraySrc = Nothing

    End If

    For lItem = 0 To lCounter - 1

        Call CoTaskMemFree(lSrcPIDL(lItem))

    Next

    RenameItems = bRet

End Function

' komplettes entpacken einer Zip-Datei
Public Function UnzipAll(ByVal sZipFile As String, ByVal sToFolder As _
    String, Optional ByVal Flags As FileOperationFlags = FOF_NO_UI) As Boolean

    Dim bRet As Boolean
    Dim FolderExists As Boolean
    Dim SHFileOp As SHFILEOPSTRUCT

    bRet = False

    If FileExists(sZipFile) = True Then

        If DirExists(sToFolder) = False Then

            FolderExists = CreatePath(sToFolder)

        Else

            FolderExists = True

        End If

        If FolderExists = True Then

            If Right$(sZipFile, 1) <> "\" Then sZipFile = sZipFile & "\"
            If Right$(sToFolder, 1) <> "\" Then sToFolder = sToFolder & "\"

            With SHFileOp

                .wFunc = FO_COPY
                .pFrom = sZipFile & "*.*" & Chr$(0) & Chr$(0)
                .pTo = sToFolder & Chr$(0) & Chr$(0)
                .fFlags = Flags

            End With

            If SHFileOperation(SHFileOp) = S_OK Then

                bRet = True

            End If
        End If
    End If

    UnzipAll = bRet

End Function

' ********************* Hilfsfunktionen ***********************

' liefert den Item-Identifier (PIDL) einer Datei oder eines Ordners
Private Function GetPIDLFromPath(ByVal sPath As String) As Long

    Dim lRet As Long
    Dim lPIDL As Long
    Dim pIShellFolder As Long

    ' IShellFolder des Desktops holen
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)

        ' PIDL einer Datei oder eines Ordners ermitteln
        lPIDL = IShellFolder.ParseDisplayName(sPath)

        If lPIDL <> 0& Then

            lRet = lPIDL

        End If

        ' aufrumen
        Set IShellFolder = Nothing

    End If

    GetPIDLFromPath = lRet

End Function

' liefert eine Pointer auf ein IDropTarget-Interface von einer PIDL
Private Function GetDropTarget(ByVal lPIDL As Long) As Long

    Dim lRet As Long
    Dim ptITEMIDLIST As Long
    Dim pIDropTarget As Long
    Dim pIShellFolder As Long
    Dim ptIID_IDropTarget As Long
    Dim psIID_IDropTarget As Long
    Dim tIID_IDropTarget(3) As Long
    Dim tITEMIDLIST As ITEMIDLIST

    ' IShellFolder des Desktops holen
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)

        ' IID_IDropTarget -> tIID_IDropTarget
        psIID_IDropTarget = StrPtr(IID_IDropTarget)
        ptIID_IDropTarget = VarPtr(tIID_IDropTarget(0))
        Call IIDFromString(psIID_IDropTarget, ptIID_IDropTarget)

        ' ITEMIDLIST fllen
        tITEMIDLIST.mkid = lPIDL
        ptITEMIDLIST = VarPtr(tITEMIDLIST)

        ' Pointer auf ein IIDropTarget-Interface ermitteln
        pIDropTarget = IShellFolder.GetUIObjectOf(0&, 1&, ptITEMIDLIST, _
            ptIID_IDropTarget)

        If pIDropTarget <> 0& Then

            lRet = pIDropTarget

        End If

        ' aufrumen
        Set IShellFolder = Nothing

    End If

    GetDropTarget = lRet

End Function

' kompletten Pfad erstellen
Private Function CreatePath(ByVal sPath As String) As Boolean

    If Right$(sPath, 1) <> "\" Then sPath = sPath & "\"

    If MakePath(sPath) = 1 Then

        CreatePath = True

    Else

        CreatePath = False

    End If

End Function

' ist eine Datei vorhanden
Private Function FileExists(ByVal sFileName As String) As Boolean

    Dim dwAttributes As Long

    dwAttributes = GetFileAttributes(sFileName)

    If dwAttributes = INVALID_FILE_ATTRIBUTES Then

        FileExists = False

    ElseIf CBool(dwAttributes And FileAttributes.FILE_ATTRIBUTE_DIRECTORY) Then

        FileExists = False

    Else

        FileExists = True

    End If

End Function

' ist ein Ordner vorhanden
Private Function DirExists(ByVal sDirectoryName As String) As Boolean

    Dim dwAttributes As Long

    If Right$(sDirectoryName, 1) <> "\" Then sDirectoryName = sDirectoryName & "\"

    dwAttributes = GetFileAttributes(sDirectoryName)

    If dwAttributes = INVALID_FILE_ATTRIBUTES Then

        DirExists = False

    ElseIf CBool(dwAttributes And FileAttributes.FILE_ATTRIBUTE_DIRECTORY) Then

        DirExists = True

    Else

        DirExists = False

    End If

End Function

